diff --git a/src/mongo/db/pipeline/window_function/window_function.h b/src/mongo/db/pipeline/window_function/window_function.h
index 6a496b9667..bbd00dde60 100644
--- a/src/mongo/db/pipeline/window_function/window_function.h
+++ b/src/mongo/db/pipeline/window_function/window_function.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/window_function/window_function_avg.h b/src/mongo/db/pipeline/window_function/window_function_avg.h
index 2dc0d09e4b..9508666e2d 100644
--- a/src/mongo/db/pipeline/window_function/window_function_avg.h
+++ b/src/mongo/db/pipeline/window_function/window_function_avg.h
@@ -29,9 +29,9 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/window_function_sum.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/window_function/window_function_covariance.cpp b/src/mongo/db/pipeline/window_function/window_function_covariance.cpp
index cab8fdb619..e255a5b8e6 100644
--- a/src/mongo/db/pipeline/window_function/window_function_covariance.cpp
+++ b/src/mongo/db/pipeline/window_function/window_function_covariance.cpp
@@ -30,8 +30,8 @@
 #include "mongo/db/pipeline/window_function/window_function_covariance.h"
 #include "mongo/db/pipeline/window_function/window_function_sum.h"
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec.h b/src/mongo/db/pipeline/window_function/window_function_exec.h
index 1fae842490..5531aa259f 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec.h
+++ b/src/mongo/db/pipeline/window_function/window_function_exec.h
@@ -31,9 +31,9 @@
 
 #include <queue>
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_set_window_fields.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_set_window_fields.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_derivative.h b/src/mongo/db/pipeline/window_function/window_function_exec_derivative.h
index ed13364a18..637f1c2476 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_derivative.h
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_derivative.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function_exec.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_derivative_test.cpp b/src/mongo/db/pipeline/window_function/window_function_exec_derivative_test.cpp
index 8968e47439..09a4a96958 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_derivative_test.cpp
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_derivative_test.cpp
@@ -30,11 +30,11 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/exec/document_value/document_value_test_util.h"
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function_exec_derivative.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_first_last.h b/src/mongo/db/pipeline/window_function/window_function_exec_first_last.h
index f64b77c28f..dc3abdac43 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_first_last.h
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_first_last.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function_exec.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_first_last_test.cpp b/src/mongo/db/pipeline/window_function/window_function_exec_first_last_test.cpp
index 0650321c46..4efc7c0faa 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_first_last_test.cpp
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_first_last_test.cpp
@@ -30,11 +30,11 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/exec/document_value/document_value_test_util.h"
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function_exec_first_last.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_non_removable.h b/src/mongo/db/pipeline/window_function/window_function_exec_non_removable.h
index 6d858d7646..a760b700a6 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_non_removable.h
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_non_removable.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function_exec.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_non_removable_range.h b/src/mongo/db/pipeline/window_function/window_function_exec_non_removable_range.h
index 2171247e0c..eac13ce9ac 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_non_removable_range.h
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_non_removable_range.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_function_exec_non_removable.h"
 
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_non_removable_test.cpp b/src/mongo/db/pipeline/window_function/window_function_exec_non_removable_test.cpp
index 960d21877c..f1a552a74c 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_non_removable_test.cpp
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_non_removable_test.cpp
@@ -30,12 +30,12 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/exec/document_value/document_value_test_util.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/accumulator_for_window_functions.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator_for_window_functions.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_removable_document.h b/src/mongo/db/pipeline/window_function/window_function_exec_removable_document.h
index 0c716f47c5..ff66dfec7d 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_removable_document.h
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_removable_document.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function_exec.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_removable_range.h b/src/mongo/db/pipeline/window_function/window_function_exec_removable_range.h
index d3c295faae..a25aae8700 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_removable_range.h
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_removable_range.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function_exec.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_exec_removable_test.cpp b/src/mongo/db/pipeline/window_function/window_function_exec_removable_test.cpp
index b681dea292..6c39882569 100644
--- a/src/mongo/db/pipeline/window_function/window_function_exec_removable_test.cpp
+++ b/src/mongo/db/pipeline/window_function/window_function_exec_removable_test.cpp
@@ -30,11 +30,11 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/exec/document_value/document_value_test_util.h"
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function_exec_non_removable.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_expression.cpp b/src/mongo/db/pipeline/window_function/window_function_expression.cpp
index 9146b5d5b7..bcb18f834b 100644
--- a/src/mongo/db/pipeline/window_function/window_function_expression.cpp
+++ b/src/mongo/db/pipeline/window_function/window_function_expression.cpp
@@ -29,11 +29,11 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/document_source_add_fields.h"
-#include "mongo/db/pipeline/document_source_project.h"
-#include "mongo/db/pipeline/document_source_set_window_fields.h"
-#include "mongo/db/pipeline/document_source_set_window_fields_gen.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/document_source/document_source_add_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_project.h"
+#include "mongo/db/pipeline/document_source/document_source_set_window_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_set_window_fields_gen.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/query/query_feature_flags_gen.h"
 
diff --git a/src/mongo/db/pipeline/window_function/window_function_expression.h b/src/mongo/db/pipeline/window_function/window_function_expression.h
index 52fe79e5b4..be90ef3055 100644
--- a/src/mongo/db/pipeline/window_function/window_function_expression.h
+++ b/src/mongo/db/pipeline/window_function/window_function_expression.h
@@ -30,10 +30,10 @@
 #pragma once
 
 #include "mongo/base/initializer.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/accumulator_for_window_functions.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_set_window_fields_gen.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator_for_window_functions.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_set_window_fields_gen.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
 #include "mongo/db/pipeline/window_function/window_function.h"
 #include "mongo/db/query/datetime/date_time_support.h"
diff --git a/src/mongo/db/pipeline/window_function/window_function_integral.cpp b/src/mongo/db/pipeline/window_function/window_function_integral.cpp
index d38e65d97c..ccc989e159 100644
--- a/src/mongo/db/pipeline/window_function/window_function_integral.cpp
+++ b/src/mongo/db/pipeline/window_function/window_function_integral.cpp
@@ -28,7 +28,7 @@
  */
 
 #include "mongo/db/pipeline/window_function/window_function_integral.h"
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/window_function/window_function_min_max.h b/src/mongo/db/pipeline/window_function/window_function_min_max.h
index 0ff212484c..44d38667c7 100644
--- a/src/mongo/db/pipeline/window_function/window_function_min_max.h
+++ b/src/mongo/db/pipeline/window_function/window_function_min_max.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 #include "mongo/db/pipeline/window_function/window_function.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/window_function/window_function_stddev.h b/src/mongo/db/pipeline/window_function/window_function_stddev.h
index 5b4aa45b07..f79a2affda 100644
--- a/src/mongo/db/pipeline/window_function/window_function_stddev.h
+++ b/src/mongo/db/pipeline/window_function/window_function_stddev.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 #include "mongo/db/pipeline/window_function/window_function.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/window_function/window_function_sum.cpp b/src/mongo/db/pipeline/window_function/window_function_sum.cpp
index 9f188184ee..fd39d189bb 100644
--- a/src/mongo/db/pipeline/window_function/window_function_sum.cpp
+++ b/src/mongo/db/pipeline/window_function/window_function_sum.cpp
@@ -29,9 +29,9 @@
 
 #include "mongo/db/pipeline/window_function/window_function_sum.h"
 
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/window_function/window_function_sum.h b/src/mongo/db/pipeline/window_function/window_function_sum.h
index 6f4b6bfaca..f391a7e584 100644
--- a/src/mongo/db/pipeline/window_function/window_function_sum.h
+++ b/src/mongo/db/pipeline/window_function/window_function_sum.h
@@ -29,9 +29,9 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/window_function.h"
 
 namespace mongo {
diff --git a/src/mongo/db/query/projection_ast.h b/src/mongo/db/query/projection_ast.h
index 3f68b7ff34..aa1a3ee8dd 100644
--- a/src/mongo/db/query/projection_ast.h
+++ b/src/mongo/db/query/projection_ast.h
@@ -33,7 +33,7 @@
 #include "mongo/db/matcher/copyable_match_expression.h"
 #include "mongo/db/matcher/expression_parser.h"
 #include "mongo/db/pipeline/dependencies.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/query/projection_ast_visitor.h"
 
 namespace mongo {
diff --git a/src/mongo/db/query/sbe_stage_builder_expression.cpp b/src/mongo/db/query/sbe_stage_builder_expression.cpp
index c282b29705..a20326062f 100644
--- a/src/mongo/db/query/sbe_stage_builder_expression.cpp
+++ b/src/mongo/db/query/sbe_stage_builder_expression.cpp
@@ -44,9 +44,9 @@
 #include "mongo/db/exec/sbe/stages/union.h"
 #include "mongo/db/exec/sbe/values/bson.h"
 #include "mongo/db/operation_context.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/expression_visitor.h"
-#include "mongo/db/pipeline/expression_walker.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/expression/expression_visitor.h"
+#include "mongo/db/pipeline/expression/expression_walker.h"
 #include "mongo/db/query/projection_parser.h"
 #include "mongo/db/query/sbe_stage_builder_eval_frame.h"
 #include "mongo/util/str.h"
diff --git a/src/mongo/db/query/sbe_stage_builder_expression.h b/src/mongo/db/query/sbe_stage_builder_expression.h
index 54ec37ab96..bfb1eef4d9 100644
--- a/src/mongo/db/query/sbe_stage_builder_expression.h
+++ b/src/mongo/db/query/sbe_stage_builder_expression.h
@@ -33,10 +33,9 @@
 #include "mongo/db/exec/sbe/stages/stages.h"
 #include "mongo/db/exec/sbe/values/value.h"
 #include "mongo/db/operation_context.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/query/sbe_stage_builder_eval_frame.h"
 #include "mongo/db/query/sbe_stage_builder_helpers.h"
-
 namespace mongo::stage_builder {
 /**
  * Translates an input Expression into an SBE EExpression. The 'stage' parameter provides the input
diff --git a/src/mongo/db/query/sort_pattern.h b/src/mongo/db/query/sort_pattern.h
index 1b55472a79..e3230a5587 100644
--- a/src/mongo/db/query/sort_pattern.h
+++ b/src/mongo/db/query/sort_pattern.h
@@ -32,7 +32,7 @@
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/pipeline/document_path_support.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 class SortPattern {
diff --git a/src/mongo/db/repl/tenant_migration_util.cpp b/src/mongo/db/repl/tenant_migration_util.cpp
index dd9934c68d..066c83401b 100644
--- a/src/mongo/db/repl/tenant_migration_util.cpp
+++ b/src/mongo/db/repl/tenant_migration_util.cpp
@@ -39,12 +39,12 @@
 #include "mongo/db/logical_time_validator.h"
 #include "mongo/db/ops/update.h"
 #include "mongo/db/ops/update_request.h"
-#include "mongo/db/pipeline/document_source_add_fields.h"
-#include "mongo/db/pipeline/document_source_graph_lookup.h"
-#include "mongo/db/pipeline/document_source_lookup.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_project.h"
-#include "mongo/db/pipeline/document_source_replace_root.h"
+#include "mongo/db/pipeline/document_source/document_source_add_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_graph_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_project.h"
+#include "mongo/db/pipeline/document_source/document_source_replace_root.h"
 #include "mongo/db/repl/repl_client_info.h"
 #include "mongo/db/repl/repl_server_parameters_gen.h"
 #include "mongo/db/repl/wait_for_majority_service.h"
diff --git a/src/mongo/db/s/resharding/document_source_resharding_iterate_transaction.h b/src/mongo/db/s/resharding/document_source_resharding_iterate_transaction.h
index 2917666fee..0d95d86ad0 100644
--- a/src/mongo/db/s/resharding/document_source_resharding_iterate_transaction.h
+++ b/src/mongo/db/s/resharding/document_source_resharding_iterate_transaction.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/s/resharding/resharding_agg_test.cpp b/src/mongo/db/s/resharding/resharding_agg_test.cpp
index b4f6299604..599a54c403 100644
--- a/src/mongo/db/s/resharding/resharding_agg_test.cpp
+++ b/src/mongo/db/s/resharding/resharding_agg_test.cpp
@@ -30,7 +30,7 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/repl/oplog_entry.h"
 #include "mongo/db/s/resharding/resharding_donor_oplog_iterator.h"
diff --git a/src/mongo/db/s/resharding/resharding_collection_cloner.cpp b/src/mongo/db/s/resharding/resharding_collection_cloner.cpp
index 7d085a3a82..3f74890464 100644
--- a/src/mongo/db/s/resharding/resharding_collection_cloner.cpp
+++ b/src/mongo/db/s/resharding/resharding_collection_cloner.cpp
@@ -44,9 +44,9 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/logical_session_id_helpers.h"
 #include "mongo/db/pipeline/aggregation_request_helper.h"
-#include "mongo/db/pipeline/document_source_lookup.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_replace_root.h"
+#include "mongo/db/pipeline/document_source/document_source_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_replace_root.h"
 #include "mongo/db/pipeline/sharded_agg_helpers.h"
 #include "mongo/db/query/query_request_helper.h"
 #include "mongo/db/s/resharding/resharding_data_copy_util.h"
diff --git a/src/mongo/db/s/resharding/resharding_collection_cloner_test.cpp b/src/mongo/db/s/resharding/resharding_collection_cloner_test.cpp
index f47186f8e9..91c20a9f70 100644
--- a/src/mongo/db/s/resharding/resharding_collection_cloner_test.cpp
+++ b/src/mongo/db/s/resharding/resharding_collection_cloner_test.cpp
@@ -37,7 +37,7 @@
 #include "mongo/bson/json.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/hasher.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/s/resharding/resharding_collection_cloner.h"
 #include "mongo/db/s/resharding/resharding_metrics.h"
 #include "mongo/db/s/resharding_util.h"
diff --git a/src/mongo/db/s/resharding/resharding_donor_oplog_iterator.cpp b/src/mongo/db/s/resharding/resharding_donor_oplog_iterator.cpp
index c8a89ab846..43085c9d7a 100644
--- a/src/mongo/db/s/resharding/resharding_donor_oplog_iterator.cpp
+++ b/src/mongo/db/s/resharding/resharding_donor_oplog_iterator.cpp
@@ -39,11 +39,11 @@
 #include "mongo/bson/bsonmisc.h"
 #include "mongo/bson/json.h"
 #include "mongo/db/client.h"
-#include "mongo/db/pipeline/document_source_lookup.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_replace_root.h"
-#include "mongo/db/pipeline/document_source_sort.h"
-#include "mongo/db/pipeline/document_source_unwind.h"
+#include "mongo/db/pipeline/document_source/document_source_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_replace_root.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_unwind.h"
 #include "mongo/db/pipeline/process_interface/mongo_process_interface.h"
 #include "mongo/db/s/resharding/resharding_server_parameters_gen.h"
 #include "mongo/db/s/resharding_util.h"
diff --git a/src/mongo/db/s/resharding/resharding_oplog_fetcher_test.cpp b/src/mongo/db/s/resharding/resharding_oplog_fetcher_test.cpp
index 958ac58878..a6f3227867 100644
--- a/src/mongo/db/s/resharding/resharding_oplog_fetcher_test.cpp
+++ b/src/mongo/db/s/resharding/resharding_oplog_fetcher_test.cpp
@@ -42,7 +42,7 @@
 #include "mongo/db/dbhelpers.h"
 #include "mongo/db/logical_session_cache_noop.h"
 #include "mongo/db/op_observer_impl.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/repl/storage_interface_impl.h"
 #include "mongo/db/repl/wait_for_majority_service.h"
 #include "mongo/db/s/operation_sharding_state.h"
diff --git a/src/mongo/db/s/resharding/resharding_txn_cloner.cpp b/src/mongo/db/s/resharding/resharding_txn_cloner.cpp
index 161c3ef953..609d7bb19b 100644
--- a/src/mongo/db/s/resharding/resharding_txn_cloner.cpp
+++ b/src/mongo/db/s/resharding/resharding_txn_cloner.cpp
@@ -46,8 +46,8 @@
 #include "mongo/db/namespace_string.h"
 #include "mongo/db/operation_context.h"
 #include "mongo/db/persistent_task_store.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/process_interface/mongo_process_interface.h"
 #include "mongo/db/pipeline/sharded_agg_helpers.h"
 #include "mongo/db/repl/optime.h"
diff --git a/src/mongo/db/s/resharding/resharding_util_test.cpp b/src/mongo/db/s/resharding/resharding_util_test.cpp
index f73b88dd76..bd8cfdd328 100644
--- a/src/mongo/db/s/resharding/resharding_util_test.cpp
+++ b/src/mongo/db/s/resharding/resharding_util_test.cpp
@@ -38,7 +38,7 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/hasher.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/repl/oplog_entry.h"
 #include "mongo/db/s/config/config_server_test_fixture.h"
diff --git a/src/mongo/db/s/resharding_util.cpp b/src/mongo/db/s/resharding_util.cpp
index 03c6a96dd3..8acc7e4c26 100644
--- a/src/mongo/db/s/resharding_util.cpp
+++ b/src/mongo/db/s/resharding_util.cpp
@@ -42,8 +42,13 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/namespace_string.h"
 #include "mongo/db/operation_context.h"
-#include "mongo/db/pipeline/document_source_add_fields.h"
-#include "mongo/db/pipeline/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_add_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_graph_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_lookup.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_replace_root.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_unwind.h"
 #include "mongo/db/s/collection_sharding_state.h"
 #include "mongo/db/s/resharding/document_source_resharding_iterate_transaction.h"
 #include "mongo/db/s/sharding_state.h"
diff --git a/src/mongo/db/s/sharding_ddl_coordinator_service.cpp b/src/mongo/db/s/sharding_ddl_coordinator_service.cpp
index 1cbd546a6f..17008ab172 100644
--- a/src/mongo/db/s/sharding_ddl_coordinator_service.cpp
+++ b/src/mongo/db/s/sharding_ddl_coordinator_service.cpp
@@ -35,7 +35,7 @@
 
 #include "mongo/base/checked_cast.h"
 #include "mongo/db/dbdirectclient.h"
-#include "mongo/db/pipeline/document_source_count.h"
+#include "mongo/db/pipeline/document_source/document_source_count.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/s/database_sharding_state.h"
 #include "mongo/db/s/operation_sharding_state.h"
diff --git a/src/mongo/db/update/pipeline_executor.cpp b/src/mongo/db/update/pipeline_executor.cpp
index 2c1f900190..af93d03416 100644
--- a/src/mongo/db/update/pipeline_executor.cpp
+++ b/src/mongo/db/update/pipeline_executor.cpp
@@ -33,7 +33,7 @@
 
 #include "mongo/bson/mutable/document.h"
 #include "mongo/db/bson/dotted_path_support.h"
-#include "mongo/db/pipeline/document_source_queue.h"
+#include "mongo/db/pipeline/document_source/document_source_queue.h"
 #include "mongo/db/pipeline/lite_parsed_pipeline.h"
 #include "mongo/db/pipeline/variable_validation.h"
 #include "mongo/db/query/query_feature_flags_gen.h"
diff --git a/src/mongo/db/update/pipeline_executor.h b/src/mongo/db/update/pipeline_executor.h
index e0b16b851c..e11d5bf24c 100644
--- a/src/mongo/db/update/pipeline_executor.h
+++ b/src/mongo/db/update/pipeline_executor.h
@@ -35,7 +35,7 @@
 #include <utility>
 #include <vector>
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/db/update/update_executor.h"
 
